// 4h


//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#ifndef FCPU_H_
#define FCPU_H_


//#define	FCPU_TPOM	281.0		// Faktyczny czas zadziaania WDG dla WDTO_30MS w ms * 10
//#define	FCPU_KOR	4.0			// Korekt dla wybranego Vcc i innychh parametrw (sprawdzone dowiadczalnie, odchyko ood zadeklarowanej FCPU_TPOM


//Table 22. Watchdog Timer Prescale Select for Atmega128
//WDP						  3.0V		  5.0V
//0 0 0    16K   (16,384)	14.8 ms		14.0 ms
//0 0 1    32K   (32,768)	29.6 ms		28.1 ms
//0 1 0    64K   (65,536)	59.1 ms		56.2 ms
//0 1 1   128K   (131,072)	 0.12 s		 0.11 s
//1 0 0   256K   (262,144)	 0.24 s		 0.22 s
//1 0 1   512K   (524,288)	 0.47 s		 0.45 s
//1 1 0 1,024K (1,048,576)	 0.95 s		 0.9  s
//1 1 1 2,048K (2,097,152)	 1.9  s		 1.8  s


//=======================================================================//
word volatile f_us NOINIT;
int fcpuDeviation;
long PomiarFCLK NOINIT;


//----------------------------------------------------------------------//
extern long fcpuCalculate();	// zwaraca fcpu = czstotliwo / 1000
								// oraz odchyk w % w "fcpuDeviation"

//=======================================================================//

#endif
