

//	(C) 2017 R-MIK Sawomir Skrzyski
//	slawomir.skrzynski@ep.com.pl


#ifndef INCLUDE_H_
#define	INCLUDE_H_


//=======================================================================//
#ifndef MAIN_NORETURN_OFF
  void main(void) __attribute__((noreturn));	// To daje 32 bajty oszczdnoci
#endif


#include	<rmik/ansi.h>
#include	<rmik/const.h>


#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <ctype.h>
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#include <util/setbaud.h>							// Uart
#include <rmik/setbaud1.h>							// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#define NOINIT __attribute__ ((section(".noinit")))
#include <avr/sleep.h>
#include <avr/power.h>
#include <avr/boot.h>


#define END_CODE_SECTION    __attribute__ ((section (".endcode")))	// *** zadeklarowa w "Memory setings"
#define BOOT_FLASH_SECTION  __attribute__ ((section (".bootflash")))// *** zadeklarowa w "Memory setings"

//													 ".bootloader" 	// *** zadeklarowa w "Memory setings"
#define BOOT_PRG_SECTION    __attribute__ ((section (".bootprg")))	// *** zadeklarowa w "Memory setings"
void endcode() END_CODE_SECTION;


#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#define jmp0()	__asm__ __volatile__( "jmp 0" )		// Wstawia rozkaz JMP 0 do kodu
#define	wdg()		wdt_reset()
#define	wdt()		wdt_reset()


//=======================================================================//
#endif
